//Yoshi by SMS Alfredo
freeslot("sfx_ysfltr")
sfxinfo[sfx_ysfltr].caption = "Hrrrrrngh"
sfxinfo[sfx_ysfltr].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysgnp1")
sfxinfo[sfx_ysgnp1].caption = "Brrrrling"
sfxinfo[sfx_ysgnp1].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysgnp2")
sfxinfo[sfx_ysgnp2].caption = "Ha!"
sfxinfo[sfx_ysgnp2].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysgnp3")
sfxinfo[sfx_ysgnp3].caption = "Brrrrling?"
sfxinfo[sfx_ysgnp3].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysgnp4")
sfxinfo[sfx_ysgnp4].caption = "Ha?"
sfxinfo[sfx_ysgnp4].flags = SF_TOTALLYSINGLE
freeslot("sfx_ystong")
sfxinfo[sfx_ystong].caption = "Glaaalng"
sfxinfo[sfx_ystong].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysaim")
sfxinfo[sfx_ysaim].caption = "Yoshi Aiming"
sfxinfo[sfx_ysaim].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysthrw")
sfxinfo[sfx_ysthrw].caption = "Wah!"
sfxinfo[sfx_ysthrw].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysnoeg")
sfxinfo[sfx_ysnoeg].caption = "Wah!"
sfxinfo[sfx_ysnoeg].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysmake")
sfxinfo[sfx_ysmake].caption = "Bum"
sfxinfo[sfx_ysmake].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysprep")
sfxinfo[sfx_ysprep].caption = "Hmmm...!"
sfxinfo[sfx_ysprep].flags = SF_TOTALLYSINGLE
freeslot("sfx_srryno")
sfxinfo[sfx_srryno].caption = ""
sfxinfo[sfx_srryno].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysflya")
sfxinfo[sfx_ysflya].caption = "Yoshi Flying"
sfxinfo[sfx_ysflya].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysflyb")
sfxinfo[sfx_ysflyb].caption = "Yoshi Flying"
sfxinfo[sfx_ysflyb].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysjmp1")
sfxinfo[sfx_ysjmp1].caption = "Ha!"
sfxinfo[sfx_ysjmp1].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysjmp2")
sfxinfo[sfx_ysjmp2].caption = "Ho!"
sfxinfo[sfx_ysjmp2].flags = SF_TOTALLYSINGLE
freeslot("sfx_ysjump")
sfxinfo[sfx_ysjump].caption = "Boing!"
freeslot("sfx_smwjmp")
sfxinfo[sfx_smwjmp].caption = "Jumping"
freeslot("sfx_yseggp")
sfxinfo[sfx_yseggp].caption = "Pop!"
sfxinfo[sfx_yseggp].flags = SF_X2AWAYSOUND
freeslot("sfx_ysgulp")
sfxinfo[sfx_ysgulp].caption = "Gulp!"
freeslot("sfx_ysspit")
sfxinfo[sfx_ysspit].caption = "Yoshi Spitting"
freeslot("sfx_ysstmp")
sfxinfo[sfx_ysstmp].caption = "Stomp"

freeslot("MT_YOSHITONGUE")
freeslot("MT_TONGUELINK")
freeslot("MT_YOSHIEGG")
freeslot("MT_FOLLOWEGG")
freeslot("MT_EGGSHELL")
freeslot("MT_YOSHIRETICULE")
freeslot("MT_YOSHIWING")
freeslot("S_YOSHI_MOUTH")
freeslot("S_YOSHI_FLUTTER")
freeslot("S_YOSHI_MAKE")
freeslot("S_YOSHI_WING_1")
freeslot("S_YOSHI_WING_2")
freeslot("S_EGG_DIE")
freeslot("S_EGG_SHELL")

states[S_YOSHI_FLUTTER] = {SPR_PLAY, SPR2_RUN|FF_ANIMATE, -1, nil, 5,  1, S_YOSHI_FLUTTER}
states[S_YOSHI_MAKE] = {SPR_PLAY, SPR2_MLEE, 10, nil, 0,  0, S_PLAY_WALK}

local yoshiable = true
local yoshieggify = false
local yoshicoin = false

addHook("NetVars", function(network)
	yoshiable = network(yoshiable)
	yoshieggify = network(yoshieggify)
end)

//Followitem used for when you have an object in your mouth
freeslot("MT_JOSHI")
mobjinfo[MT_JOSHI] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}
addHook("MobjSpawn", function(mobj)
	mobj.shadowscale = FRACUNIT
end, MT_JOSHI)
addHook("FollowMobj", function(player, mobj)
	if not (player.mo and player.mo.valid and mobj and mobj.valid) return true end
	if player.mouthobj and player.mouthobj.valid
		if player.mouthobj.player then player.backdraft = 0 end
		mobj.skin = player.mo.skin
		mobj.state = player.mo.state
		mobj.frame = player.mo.frame
		mobj.sprite2 = player.mo.sprite2|FF_SPR2SUPER
		mobj.angle = player.drawangle
		mobj.color = player.mo.color
		mobj.colorized = player.mo.colorized
		mobj.scale = player.mo.scale
		mobj.radius = player.mo.radius
		mobj.height = player.mo.height
		mobj.flags2 = player.mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
		mobj.eflags = player.mo.eflags&MFE_VERTICALFLIP
		player.mo.flags2 = $|MF2_DONTDRAW
		mobj.flags2 = $&~MF2_LINKDRAW
	elseif mobj.state != S_INVISIBLE
		mobj.state = S_INVISIBLE
	end
	P_TeleportMove(mobj,player.mo.x,player.mo.y,player.mo.z)
	return true
end, MT_JOSHI)

//Egg Count HUD
hud.add(function(v, stplyr, cam)
	local zehcolor = stplyr.skincolor
	if stplyr.mo and stplyr.mo.valid then zehcolor = stplyr.mo.color end
	if stplyr.powers[pw_super] > 1 then zehcolor = SKINCOLOR_BLUE end
	local i = 0
	while stplyr.yosheggs != nil and i < stplyr.yosheggs
		v.drawScaled(20*FRACUNIT+(i*7*FRACUNIT), 175*FRACUNIT, FRACUNIT/2, v.getSpritePatch(SPR_YEGG, 0), V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap(nil, zehcolor))
		i = $+1
	end
end, "game")

//Hurt messages adapted from Battle Mod
addHook("HurtMsg", function(player, inflictor, source)
	local playertext = player.name
	if G_GametypeHasTeams() then
		if player.ctfteam == 1 then playertext = "\x85"..$.."\x80" end
		if player.ctfteam == 2 then playertext = "\x84"..$.."\x80" end
	end
	
	if source and source.valid and source.player
		local sourcetext = source.player.name
		if G_GametypeHasTeams() then
			if source.player.ctfteam == 1 then sourcetext = "\x85"..$.."\x80" end
			if source.player.ctfteam == 2 then sourcetext = "\x84"..$.."\x80" end
		end
		if player.mo.health > 0
			print(playertext.." was hit by "..sourcetext.."'s flying egg.")
		else
			print(playertext.." was killed by "..sourcetext.."'s flying egg.")
		end
	elseif player.mo.health > 0
		print(playertext.." was hit by someone's flying egg.")
	else
		print(playertext.." was killed by someone's flying egg.")
	end
	return true
end, MT_YOSHIEGG)

//yoshigrief command
COM_AddCommand("yoshigrief", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			yoshiable = false
			CONS_Printf(player, "Yoshi can no longer lick up other players.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			yoshiable = true
			CONS_Printf(player, "Yoshi can now lick up other players.")
		elseif yoshiable
			CONS_Printf(player, "yoshigrief [on/off] - When on, Yoshi players can lick up other players. Currently on, which is the default.")
		else
			CONS_Printf(player, "yoshigrief [on/off] - When on, Yoshi players can lick up other players. Currently off, which is no fun.")
		end
	elseif yoshiable
		CONS_Printf(player, "yoshigrief [on/off] - When on, Yoshi players can lick up other players. Currently on, which is the default.")
	else
		CONS_Printf(player, "yoshigrief [on/off] - When on, Yoshi players can lick up other players. Currently off, which is no fun.")
	end
end, 1)

//yoshieggify command
COM_AddCommand("yoshieggify", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			yoshieggify = false
			CONS_Printf(player, "Yoshi can no longer turn other players into eggs.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			yoshieggify = true
			CONS_Printf(player, "Yoshi can now turn other players into eggs.")
		elseif yoshieggify
			CONS_Printf(player, "yoshieggify [on/off] - When on, Yoshi players can turn other players into eggs, killing them. Currently on, which probably a mistake.")
		else
			CONS_Printf(player, "yoshieggify [on/off] - When on, Yoshi players can turn other players into eggs, killing them. Currently off, which is the default.")
		end
	elseif yoshieggify
		CONS_Printf(player, "yoshieggify [on/off] - When on, Yoshi players can turn other players into eggs, killing them. Currently on, which probably a mistake.")
	else
		CONS_Printf(player, "yoshieggify [on/off] - When on, Yoshi players can turn other players into eggs, killing them. Currently off, which is the default.")
	end
end, 1)

//yoshicoin command
COM_AddCommand("yoshicoin", function(player, arg)
	if netgame then CONS_Printf(player, "This can't be used in a netgame!") return end
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "false" or arg == "off"
			yoshicoin = false
			CONS_Printf(player, "Rings will now no longer turn into coins.")
		elseif arg == "1" or arg == "default" or arg == "true" or arg == "on"
			yoshicoin = true
			CONS_Printf(player, "All rings have been changed into coins.")
		elseif yoshicoin
			CONS_Printf(player, "yoshicoin [on/off] - When on, all rings are turned into coins. Currently on.")
		else
			CONS_Printf(player, "yoshicoin [on/off] - When on, all rings are turned into coins. Currently off.")
		end
	elseif yoshicoin
		CONS_Printf(player, "yoshicoin [on/off] - When on, all rings are turned into coins. Currently on.")
	else
		CONS_Printf(player, "yoshicoin [on/off] - When on, all rings are turned into coins. Currently off.")
	end
end, 0)

//yoshijump command
COM_AddCommand("yoshijump", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "yoshi's island" or arg == "yoshis island" or arg == "yi"
			player.yoshijump = 0
			CONS_Printf(player, "Yoshi will now use the Yoshi's Island jumping sfx.")
		elseif arg == "1" or arg == "super mario world" or arg == "mario world" or arg == "smw"
			player.yoshijump = 1
			CONS_Printf(player, "Yoshi will now use the Super Mario World jumping sfx.")
		elseif arg == "2" or arg == "yoshi's island ds" or arg == "yoshis island ds" or arg == "yids"
			player.yoshijump = 2
			CONS_Printf(player, "Yoshi will now use the Yoshi's Island DS jumping sfx.")
		else
			CONS_Printf(player, "yoshijump - Switches what jump sound effect Yoshi uses. Possible sounds are as follows:")
			CONS_Printf(player, "#0: Yoshi's Island")
			CONS_Printf(player, "#1: Super Mario World")
			CONS_Printf(player, "#2: Yoshi's Island DS")
		end
	else
		CONS_Printf(player, "yoshijump - Switches what jump sound effect Yoshi uses. Possible sounds are as follows:")
		CONS_Printf(player, "#0: Yoshi's Island")
		CONS_Printf(player, "#1: Super Mario World")
		CONS_Printf(player, "#2: Yoshi's Island DS")
	end
end, 0)

//yoshithrow command
COM_AddCommand("yoshithrow", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "default" or arg == "patient"
			player.yoshithrow = false
			CONS_Printf(player, "Throw style has been changed to Patient.")
		elseif arg == "1" or arg == "hasty"
			player.yoshithrow = true
			CONS_Printf(player, "Throw style has been changed to Hasty.")
		else
			CONS_Printf(player, "yoshithrow [patient/hasty] - Changes the throw style. With Patient you have to press custom 1 a second time to throw. With Hasty you just need to let go of the button.")
		end
	else
		CONS_Printf(player, "yoshithrow [patient/hasty] - Changes the throw style. With Patient you have to press custom 1 a second time to throw. With Hasty you just need to let go of the button.")
	end
end, 0)

//yoshiautoaim command
COM_AddCommand("yoshiautoaim", function(player, arg)
	if not (player.mo and player.mo.valid) then CONS_Printf(player, "This can only be used in a level!") return end
	if arg
		if arg == "0" or arg == "off" or arg == "false"
			player.yoshiautoaim = false
			CONS_Printf(player, "Yoshi will no longer automatically aim at enemies")
		elseif arg == "1" or arg == "on" or arg == "default" or arg == "true"
			player.yoshiautoaim = true
			CONS_Printf(player, "Yoshi will now automatically aim at enemies")
		else
			CONS_Printf(player, "yoshiautoaim [on/off] - Toggles whether or not Yoshi automatically aims at enemies.")
		end
	else
		CONS_Printf(player, "yoshiautoaim [on/off] - Toggles whether or not Yoshi automatically aims at enemies.")
	end
end, 0)

//Egg Spawning function
local SpawnEgg = function (player)
	player.yosheggs = $+1
	local egg = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_FOLLOWEGG)
	egg.threshold = player.yosheggs
	egg.tracer = player.mo
	egg.color = player.mo.color
end

//Makes A_RingBox give you an egg when you're Yoshi, except when in Battle
function A_RingBox(actor, var1, var2)
    super(actor, var1, var2)
    if actor.target and actor.target.valid and actor.target.player
	and not (CBW_Battle and CBW_Battle.BattleGametype)
	and actor.target.skin == "yoshi"
	and actor.target.player.yosheggs < 8 then SpawnEgg(actor.target.player) end
end

//tfw you copy and paste code from your very own Cash Banooca
local EnemyLookDeluxe = function(player, distancemulti, span)
	if not (player.mo and player.mo.valid) return end
	local maxdist = FixedMul((RING_DIST*distancemulti), player.mo.scale)
	local thokmobj = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_THOK)
	thokmobj.radius = maxdist
	local closestmo = nil
	local closestdist = 0

	searchBlockmap("objects", function(refmobj, mo)
		//Prevent targeting Battle's target dummy since we can target players anyways
		if (pcall(function() local v = _G["MT_TARGETDUMMY"] end, "MT_TARGETDUMMY")
		and mo.type == _G["MT_TARGETDUMMY"]) then return end
		
		local trash = R_PointToAngle2(player.mo.x, player.mo.y, mo.x, mo.y)
		
		if mo == player.mouthmobj or (mo.flags & MF_NOCLIPTHING)
		or mo.mouthed or mo.health <= 0
		or mo == player.mo or mo.flags2 & MF2_FRET or not P_CheckSight(player.mo, mo)
		or ((twodlevel or player.mo.flags2 & MF2_TWOD) and abs(player.mo.y-mo.y) > player.mo.radius)
		or ((trash - player.mo.angle > span) or (trash - player.mo.angle < -1*span))
		return end

		if mo.player
			if mo.player.spectator
				return
			elseif G_GametypeHasTeams() and mo.player.ctfteam == player.ctfteam
				return
			elseif G_TagGametype() and (mo.player.pflags & PF_TAGIT) == (player.pflags & PF_TAGIT)
				return
			elseif G_PlatformGametype() and not (CBW_Battle and CBW_Battle.BattleGametype())
				return
			end
		elseif mo.flags & (MF_MONITOR) and (G_RingSlingerGametype() or (CBW_Battle and CBW_Battle.BattleGametype()))
			return
		elseif (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (mo.flags & MF_SHOOTABLE))) == !(mo.flags2 & MF2_INVERTAIMABLE)) // allows if it has the flags desired XOR it has the invert aimable flag
			return // not a valid target
		end
		
		local zdist = (player.mo.z + player.mo.height/2) - (mo.z + mo.height/2)
		local dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)
		if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2) and ((R_PointToAngle2(0, 0, dist, -1*zdist) + span) > span*2)
			return // Don't home outside of desired angle!
		end

		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist) or (closestmo and dist > closestdist)
			return // out of range
		end

		closestmo = mo
		closestdist = dist
	end, thokmobj)
	
	P_RemoveMobj(thokmobj)
	return closestmo
end

//Custom version of A_VileFire used for Yoshi's tongue
function A_VileTongue(actor, locvar1, locvar2)
	if (actor.flags2 & MF2_DONTDRAW) or not (actor.tracer and actor.tracer.valid) then return end
	local xoffset = P_ReturnThrustX(nil, actor.angle, 10*actor.tracer.scale)+actor.tracer.x
	local yoffset = P_ReturnThrustY(nil, actor.angle, 10*actor.tracer.scale)+actor.tracer.y

	// Now draw the line to the object from the tracer
	local numLineMobjs = min(max(R_PointToDist2(actor.x, actor.y, xoffset, yoffset)/(actor.scale*4), 16), 64)
	
	// Get distance for each step
	local distX = (xoffset - actor.x) / numLineMobjs
	local distY = (yoffset - actor.y) / numLineMobjs
	local distZ = ((actor.tracer.z + actor.tracer.height*4/7) - actor.z) / numLineMobjs
	if (actor.tracer.eflags & MFE_VERTICALFLIP) then distZ = (((actor.tracer.z + actor.tracer.height) - actor.tracer.height*4/7) - actor.z-actor.height) / numLineMobjs end
			
	local i = 0
	while (i <= numLineMobjs)
		local part
		if (actor.tracer.eflags & MFE_VERTICALFLIP)
			part = P_SpawnMobj(actor.x + (distX * i), actor.y + (distY * i), (actor.z+actor.height) + (distZ * i), MT_TONGUELINK)
			part.frame = B
		else
			part = P_SpawnMobj(actor.x + (distX * i), actor.y + (distY * i), actor.z + (distZ * i), MT_TONGUELINK)
		end
		part.scale = actor.scale/2
		part.fuse = 2
		i = $+1
	end
end

//Code for detecting when the tongue touches an object
addHook("MobjMoveCollide", function(tmthing, thing)
	if not (tmthing and tmthing.valid and thing and thing.valid and tmthing.tracer != thing) then return end
	if not (tmthing.tracer and tmthing.tracer.player and tmthing.tracer.player.prevmouthobj != thing) then return end
	if G_GametypeHasTeams() and thing.ctfteam and thing.ctfteam == tmthing.tracer.player.ctfteam then return end
	if thing.mouthed and thing.mouthed > 0 then return end
	if thing.player and (thing.player.panim == PA_PAIN or thing.player.spectator
	or (G_GametypeHasTeams() and thing.player.gotflag > 0 and
	thing.player.gotflag != tmthing.tracer.player.ctfteam)) then return end
	if thing.health <= 0 then return end
	if thing.flags2&MF2_FRET then return end
	if tmthing.tracer == thing or tmthing.target != nil then return end
	if (thing.flags & MF_BOSS) then return end
	if not ((thing.flags & MF_ENEMY) or thing.type == MT_DRAGONMINE or thing.type == MT_UNIBALL
	//or (yoshiable and (thing.type ==  MT_YELLOWSPRING or thing.type ==  MT_REDSPRING or thing.type ==  MT_BLUESPRING))
	or thing.type == MT_GOOP or (thing.flags & MF_MISSILE) or thing.type == MT_TNTBARREL //or (thing.flags & MF_PUSHABLE) 
	or thing.type == MT_EGGROBO1 or (thing.flags & MF_MONITOR)
	or (thing.player and thing.player.powers[pw_flashing] == 0 and thing.player.powers[pw_invulnerability] == 0) and yoshiable)
	then return end
	//We just have so many exceptions here
	if thing.type == MT_CRUSHSTACEAN or thing.type == MT_BANPYURA or thing.type == MT_UNIDUS
	or thing.type == MT_POINTY or thing.type == MT_GSNAPPER then return end
	if not (abs(thing.z - tmthing.z) <= 80*thing.scale) then return end
	local trash = R_PointToAngle2(tmthing.tracer.x, tmthing.tracer.y, thing.x, thing.y)
	if (trash - tmthing.angle > ANGLE_45) or (trash - tmthing.angle < -1*ANGLE_45) then return end
	//Ones you damage instead of licking up (disables tongue hitbox if not a monitor)
	if thing.type == MT_YELLOWSHELL or thing.health > 1 or (thing.flags & MF_MONITOR)
	then if not (thing.flags & MF_MONITOR) tmthing.flags = $|MF_NOCLIPTHING end
	P_DamageMobj(thing, tmthing, tmthing.tracer) return end
	//Replaces certain objects with a Crawla to prevent jank
	local gotthing = thing
	if thing.type == MT_BUGGLE or thing.type == MT_EGGROBO1 or thing.type == MT_PTERABYTE
	or thing.type == MT_PYREFLY or thing.type == MT_SPINBOBERT or thing.type == MT_UNIBALL
	or thing.type == MT_DRAGONBOMBER
	or (pcall(function() local v = _G["MT_BUZZBUDDY"] end, "MT_BUZZBUDDY") and thing.type == _G["MT_BUZZBUDDY"])
	or (pcall(function() local v = _G["MT_EGGTURRET"] end, "MT_EGGTURRET") and thing.type == _G["MT_EGGTURRET"])
		gotthing = P_SpawnMobjFromMobj(tmthing,0,0,0,MT_BLUECRAWLA)
		gotthing.yoshidummy = true
		P_SetMobjStateNF(gotthing,thing.info.spawnstate)
		gotthing.color = thing.color
		gotthing.scale = thing.scale
		if thing.info.deathstate == S_NULL or thing.type == MT_EGGROBO1 then gotthing.info.deathstate = S_XPLD_FLICKY
		else gotthing.info.deathstate = thing.info.deathstate end
		P_RemoveMobj(thing)
	end
	if gotthing.player
		gotthing.player.homing = 0
		//if tmthing.tracer.player and G_GametypeHasTeams() and tmthing.tracer.player.ctfteam == gotthing.player.ctfteam then return end
		if gotthing.player.powers[pw_carry] != CR_NONE then return end
		if CBW_Battle
			CBW_Battle.DoSPriority(gotthing.player,tmthing.tracer)
			local priority = gotthing.player.battle_def
			if priority > 0
				tmthing.reactiontime = -44
				tmthing.flags = $|MF_NOCLIPTHING
				gotthing.player.panim = PA_FALL
				gotthing.state = S_PLAY_FALL
				gotthing.player.pflags = $&~(PF_GLIDING|PF_JUMPED|PF_BOUNCING|PF_THOKKED|PF_SPINNING)
				if gotthing.player.charability == CA_TWINSPIN then gotthing.player.pflags = $|PF_JUMPED end
				gotthing.momx = 0
				gotthing.momy = 0
				gotthing.momz = 0
				tmthing.tracer.recoilthrust = tmthing.tracer.scale*10
				tmthing.tracer.recoilangle = R_PointToAngle2(gotthing.x-thing.momx,gotthing.y-thing.momy,tmthing.tracer.x-tmthing.tracer.momx,tmthing.tracer.y-tmthing.tracer.momy)
				tmthing.tracer.player.powers[pw_nocontrol] = tmthing.tracer.recoilthrust/tmthing.tracer.scale*4
				S_StartSound(tmthing.tracer,sfx_s3k5d)
			return end
		end
		P_ResetPlayer(gotthing.player)
		//Yoshi uses carry type 13, which is unused normally
		gotthing.player.powers[pw_carry] = 13
		gotthing.state = S_PLAY_PAIN
	end
	gotthing.yoshflags = gotthing.flags
	gotthing.yoshstate = gotthing.state
	gotthing.yoshscale = gotthing.scale
	if (gotthing.flags & MF_MONITOR)
		gotthing.flags = MF_NOCLIP & MF_NOCLIPHEIGHT & MF_NOCLIPTHING & MF_SCENERY & MF_NOGRAVITY & MF_MONITOR
		gotthing.target = tmthing.tracer
	elseif (gotthing.flags & MF_ENEMY)
		gotthing.flags = MF_NOCLIP & MF_NOCLIPHEIGHT & MF_NOCLIPTHING & MF_SCENERY & MF_NOGRAVITY & MF_ENEMY
	else
		gotthing.flags = MF_NOCLIP & MF_NOCLIPHEIGHT & MF_NOCLIPTHING & MF_SCENERY & MF_NOGRAVITY
	end
	gotthing.tracer = tmthing.tracer
	gotthing.tics = -1
	gotthing.mouthed = 1
	P_TryMove(gotthing, tmthing.x, tmthing.y, true)
	gotthing.z = tmthing.z
	tmthing.target = gotthing
end, MT_YOSHITONGUE)

//Code for changing an object's state when tongued
local mouththink = function(mobj)
	if mobj.mouthed == nil or mobj.mouthed == 0 return end
	if mobj.player then mobj.player.backdraft = 0 end
	if mobj.player and not (mobj.mouthed >= 3 and (gametyperules&GTR_FRIENDLY
	or (G_GametypeHasTeams() and mobj.player.ctfteam == mobj.tracer.player.ctfteam)))
	then mobj.player.pflags = $|PF_FULLSTASIS end
	local validyoshi = (mobj.tracer and mobj.tracer.valid and mobj.tracer.skin == "yoshi"
	and mobj.tracer.player and mobj.tracer.player.playerstate == PST_LIVE
	and not mobj.tracer.player.spectator)
	if not validyoshi then mobj.mouthed = 10 end
	if validyoshi and mobj.mouthed > 3 then mobj.tracer.player.mouthobj = nil end
	if mobj.mouthed > 4
		mobj.flags2 = $ & ~MF2_DONTDRAW
		if mobj.player and mobj.player.powers[pw_carry] == 13 then mobj.player.powers[pw_carry] = CR_NONE end
		if (mobj.info.deathstate == S_NULL or mobj.player or mobj.mouthed == 10 or not validyoshi) 
		and not mobj.yoshidummy
			if mobj.player
				mobj.player.shieldscale = skins[mobj.skin].shieldscale
				if (G_GametypeHasTeams() and mobj.player.ctfteam == mobj.tracer.player.ctfteam)
				or gametyperules&GTR_FRIENDLY mobj.yoshstate = S_PLAY_ROLL
				mobj.player.pflags = $|PF_SPINNING|PF_JUMPSTASIS mobj.player.yoshiairfriendly = true
				else P_ResetPlayer(mobj.player) mobj.player.yoshiairfriendly = false end
				mobj.player.yoshiairjump = 3
			end
			mobj.state = mobj.yoshstate
			mobj.flags = mobj.yoshflags
		else
			if (mobj.flags & MF_MONITOR)
				mobj.flags = MF_MISSILE & MF_SCENERY & MF_MONITOR
			elseif (mobj.flags & MF_ENEMY)
				mobj.flags = MF_MISSILE & MF_SCENERY & MF_ENEMY
				mobj.tics = -1
				mobj.fuse = TICRATE*2
				mobj.info.xdeathstate = mobj.info.deathstate
			else
				mobj.flags = MF_MISSILE
				mobj.tics = -1
				mobj.fuse = TICRATE*2
				mobj.info.xdeathstate = mobj.info.deathstate
			end
			if P_IsObjectOnGround(mobj)
				if (mobj.eflags & MFE_VERTICALFLIP)
					mobj.z = $-mobj.scale
				else
					mobj.z = $+mobj.scale
				end
			end
			P_SetMobjStateNF(mobj, mobj.yoshstate)
		end
		
		if mobj.yoshscale then mobj.scale = mobj.yoshscale mobj.yoshscale = nil end
		
		mobj.mouthed = 0
	elseif mobj.mouthed >= 3
		mobj.flags2 = $ & ~MF2_DONTDRAW
		
		if mobj.player
			if (G_GametypeHasTeams() and mobj.player.ctfteam == mobj.tracer.player.ctfteam)
			or gametyperules&GTR_FRIENDLY mobj.yoshstate = S_PLAY_ROLL
			mobj.player.pflags = $|PF_SPINNING|PF_JUMPSTASIS end
			mobj.state = mobj.yoshstate
			mobj.player.shieldscale = skins[mobj.skin].shieldscale
		else
			P_SetMobjStateNF(mobj, mobj.yoshstate)
		end
		
		if mobj.yoshscale then mobj.scale = mobj.yoshscale mobj.yoshscale = nil end
		
		if (mobj.flags & MF_MONITOR)
			mobj.flags = MF_NOCLIPTHING & MF_SCENERY & MF_MONITOR
		elseif (mobj.flags & MF_ENEMY)
			mobj.flags = MF_NOCLIPTHING & MF_SCENERY & MF_ENEMY
		else
			mobj.flags = MF_NOCLIPTHING & MF_SCENERY
		end
		mobj.tics = -1
		mobj.mouthed = $+1
	elseif mobj.mouthed == 2
		if mobj.yoshscale then mobj.scale = mobj.yoshscale mobj.yoshscale = nil end
		mobj.state = S_YOSHI_MOUTH
		mobj.flags2 = $|MF2_DONTDRAW
		P_SetObjectMomZ(mobj, 0, false)
		P_InstaThrust(mobj, mobj.angle, 0)
		
		//Mashing code
		if mobj.player
			mobj.player.powers[pw_underwater] = 1050
			mobj.player.powers[pw_spacetime] = 402
			mobj.player.shieldscale = 0
			
			if mobj.player.cmd.buttons == 0 then
				mobj.player.mashtapready = true
				mobj.player.mashtapping = false
			elseif mobj.player.mashtapready then
				mobj.player.mashtapping = true
				mobj.player.mashtapready = false
			else
				mobj.player.mashtapping = false
			end
			
			if mobj.player.mashtapping
				mobj.player.yoshmash = $+1
				if mobj.player.yoshmash > 3
					mobj.mouthed = 3
					mobj.state = mobj.yoshstate
					mobj.player.shieldscale = skins[mobj.skin].shieldscale
					mobj.tics = -1
					P_TeleportMove(mobj, mobj.tracer.x, mobj.tracer.y, mobj.tracer.height/2+mobj.tracer.z)
					mobj.tracer.player.mouthobj = nil
					S_StartSound(mobj.tracer, sfx_ysspit)
				else
					S_StartSound(mobj, sfx_mario2)
				end
			end
		end
	else
		mobj.scale = $*39/40
		if mobj.player
			mobj.player.yoshmash = 0
			mobj.player.mashtapping = false
			mobj.player.mashtapready = false
		end
		if (mobj.flags & MF_MONITOR)
			mobj.flags = MF_NOCLIP & MF_NOCLIPHEIGHT & MF_NOCLIPTHING & MF_SCENERY & MF_NOGRAVITY & MF_MONITOR
		elseif (mobj.flags & MF_ENEMY)
			mobj.flags = MF_NOCLIP & MF_NOCLIPHEIGHT & MF_NOCLIPTHING & MF_SCENERY & MF_NOGRAVITY & MF_ENEMY
		else
			mobj.flags = MF_NOCLIP & MF_NOCLIPHEIGHT & MF_NOCLIPTHING & MF_SCENERY & MF_NOGRAVITY
		end
		mobj.tics = -1
		P_SetObjectMomZ(mobj, 0, false)
		P_InstaThrust(mobj, mobj.angle, 0)
	end
end

//Alternate version of A_CapeChase that will never despawn the object calling it
function A_MouthChase(actor, locvar1, locvar2)
	if actor.tracer == nil or not (actor.tracer and actor.tracer.valid)
	or not (actor.tracer.player and actor.tracer.player.mouthobj == actor)
	actor.mouthed = 10 mouththink(actor) return end
	
	local angle = actor.tracer.angle
	if actor.tracer.player then angle = actor.tracer.player.drawangle end
	
	local foffsetx = P_ReturnThrustX(actor.tracer, angle, FixedMul((locvar2 >> 16)*FRACUNIT, actor.scale))
	local foffsety = P_ReturnThrustY(actor.tracer, angle, FixedMul((locvar2 >> 16)*FRACUNIT, actor.scale))

	local boffsetx = P_ReturnThrustX(actor.tracer, angle-ANGLE_90, FixedMul((locvar2 & 65535)*FRACUNIT, actor.scale))
	local boffsety = P_ReturnThrustY(actor.tracer, angle-ANGLE_90, FixedMul((locvar2 & 65535)*FRACUNIT, actor.scale))
	
	P_TeleportMove(actor, actor.tracer.x + foffsetx + boffsetx, actor.tracer.y + foffsety + boffsety, actor.z)
	
	if (actor.tracer.eflags & MFE_VERTICALFLIP)
		actor.eflags = $|MFE_VERTICALFLIP
		actor.flags2 = $|MF2_OBJECTFLIP
		actor.z = actor.tracer.z + actor.tracer.height - actor.height - FixedMul((locvar1 >> 16)*FRACUNIT, actor.scale)
	else
		actor.eflags = $ & ~MFE_VERTICALFLIP
		actor.flags2 = $ & ~MF2_OBJECTFLIP
		actor.z = actor.tracer.z + FixedMul((locvar1 >> 16)*FRACUNIT, actor.scale)
	end
	
	actor.angle = angle
end

//Fixes team switching being prevented by being in Yoshi's mouth
addHook("TeamSwitch", function(player, team, fromspectators, autobalance, scramble)
	if player.mo and player.mo.valid and player.mo.mouthed and player.mo.mouthed < 10
		player.mo.mouthed = 10
		mouththink(player.mo)
	end
end)

//Really make sure that any mouthed objects are un-mouthed when a player leaves
addHook("PlayerQuit", function(player, reason)
	if player.tongue and player.tongue.valid and player.tongue.target
	and player.tongue.target.valid and player.tongue.target.mouthed
		player.tongue.target.mouthed = 10
		mouththink(player.tongue.target)
	elseif player.mouthobj and player.mouthobj.valid and player.mouthobj.mouthed
		player.mouthobj.mouthed = 10
		mouththink(player.mouthobj)
	elseif player.prevmouthobj and player.prevmouthobj.valid and player.prevmouthobj.mouthed
		player.prevmouthobj.mouthed = 10
		mouththink(player.prevmouthobj)
	end
	
	if player.tongue and player.tongue.valid then P_KillMobj(player.tongue) end
end)

//Prevents mouthed objects from doing TouchSpecial, just in case
addHook("TouchSpecial", function(special, toucher)
	if special and special.valid and special.mouthed and special.mouthed > 0 then return true end
	if toucher and toucher.valid and toucher.mouthed and toucher.mouthed > 0 then return true end
end)

//Same with being damaged
addHook("ShouldDamage", function(target, inflictor, source)
	if target and target.valid and target.mouthed and target.mouthed > 0 then return false end
	if inflictor and inflictor.valid and inflictor.mouthed and inflictor.mouthed > 0 then return false end
	if source and source.valid and source.mouthed and source.mouthed > 0 then return false end
end)

addHook("MobjDamage", function(target, inflictor, source)
	if target and target.valid and target.mouthed and target.mouthed > 0 then return true end
	if inflictor and inflictor.valid and inflictor.mouthed and inflictor.mouthed > 0 then return true end
	if source and source.valid and source.mouthed and source.mouthed > 0 then return true end
end)

//Same with Collision Checks
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and thing.mouthed and thing.mouthed > 0 then return false end
	if tmthing and tmthing.valid and tmthing.mouthed and tmthing.mouthed > 0 then return false end
end)

addHook("MobjMoveCollide", function(thing, tmthing)
	if thing and thing.valid and thing.mouthed and thing.mouthed > 0 then return false end
	if tmthing and tmthing.valid and tmthing.mouthed and tmthing.mouthed > 0 then return false end
end)

//Egg Shatter
addHook("MobjThinker", function(mobj)
	if mobj.state != S_EGG_DIE then return end
	local eggshell
	local i = 0
	while i < 4
		eggshell = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_EGGSHELL)
		//eggshell.eflags = $ & ~MFE_VERTICALFLIP
		//eggshell.flags2 = $ & ~MF2_OBJECTFLIP
		eggshell.rollangle = i*ANGLE_90
		if i % 2 eggshell.rollangle = $-ANGLE_45 end
		eggshell.color = mobj.color
		eggshell.angle = mobj.angle + ANGLE_90
		eggshell.threshold = i
		eggshell.fuse = 1
		i = $+1
	end
	S_StartSound(eggshell, sfx_yseggp)
	mobj.state = S_NULL
end, MT_YOSHIEGG)

addHook("MobjFuse", function(mobj)
	local yspeed = 5*FRACUNIT
	if mobj.threshold == 1 or mobj.threshold == 2 yspeed = $/2 end
	local xspeed = 5*FRACUNIT
	if mobj.threshold > 1 xspeed = $*-1 end
	P_SetObjectMomZ(mobj, yspeed, false)
	P_InstaThrust(mobj, mobj.angle, xspeed)
	mobj.z = $+(P_MobjFlip(mobj)*10*mobj.scale)
	return true
end, MT_EGGSHELL)

//Egg Wall Breaker Function
local eggwallbreak = function(mobj, sectorthing)
	local nerds = false
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Egg Wall Breaker
addHook("MobjLineCollide", function(mobj, line)
	local killone
	local killtwo
	if not (line and line.valid and mobj and mobj.valid) then return end
	if line.frontsector and line.frontsector.valid then killone = eggwallbreak(mobj, line.frontsector) end
	if line.backsector and line.backsector.valid then killtwo = eggwallbreak(mobj, line.backsector) end
	if killone or killtwo then P_KillMobj(mobj) end
end, MT_YOSHIEGG)

//Follower Egg Thinker, Adapted from Homing Attack Code
addHook("MobjThinker", function(mobj)
	if not (mobj.tracer and mobj.tracer.valid and mobj.tracer.player
	and mobj.tracer.skin == "yoshi"
	and mobj.tracer.player.yosheggs >= mobj.threshold and mobj.tracer.player.playerstate == PST_LIVE) then P_KillMobj(mobj) return end
	mobj.destscale = mobj.tracer.scale*3/2
	
	if mobj.tracer.mouthed and mobj.tracer.mouthed > 0
		if not (mobj.flags2 & MF2_DONTDRAW) then mobj.flags2 = $|MF2_DONTDRAW end
	elseif (mobj.flags2 & MF2_DONTDRAW)
		mobj.flags2 = $ & ~MF2_DONTDRAW
	end
	
	if mobj.tracer.player.powers[pw_super] > 1
		mobj.color = SKINCOLOR_BLUE
	else
		mobj.color = mobj.tracer.color
	end
	
	if (mobj.tracer.eflags & MFE_VERTICALFLIP)
		mobj.eflags = $|MFE_VERTICALFLIP
		mobj.flags2 = $|MF2_OBJECTFLIP
	else
		mobj.eflags = $ & ~MFE_VERTICALFLIP
		mobj.flags2 = $ & ~MF2_OBJECTFLIP
	end
	
	if mobj.tracer.player.eggshoot and mobj.threshold == mobj.tracer.player.yosheggs
		mobj.momx = 0
		mobj.momy = 0
		mobj.momz = 0
		P_TeleportMove(mobj, P_ReturnThrustX(nil, mobj.tracer.player.drawangle-ANGLE_67h, 20*mobj.tracer.scale)+mobj.tracer.x,
		P_ReturnThrustY(nil, mobj.tracer.player.drawangle-ANGLE_67h, 20*mobj.tracer.scale)+mobj.tracer.y,
		mobj.tracer.z+(mobj.tracer.height/4))
		if (mobj.tracer.eflags & MFE_VERTICALFLIP) then mobj.z = mobj.tracer.z+mobj.tracer.height-mobj.height-(mobj.tracer.height/4) end
		return
	end
	
	local thex = mobj.tracer.x + P_ReturnThrustX(mobj.tracer, mobj.tracer.player.drawangle, -30*mobj.tracer.scale*mobj.threshold)
	local they = mobj.tracer.y + P_ReturnThrustY(mobj.tracer, mobj.tracer.player.drawangle, -30*mobj.tracer.scale*mobj.threshold)
	local theyz = mobj.tracer.z - (mobj.tracer.momz*((mobj.threshold*2)+1))
	
	mobj.angle = R_PointToAngle2(mobj.x, mobj.y, thex, they)

	local zdist = theyz - mobj.z
	if (P_MobjFlip(mobj) == -1) then zdist = (theyz + mobj.tracer.height) - (mobj.z + mobj.height) end
	
	local dist = P_AproxDistance(P_AproxDistance(thex - mobj.x, they - mobj.y), zdist)

	if (dist < 1) then dist = 1 end
	
	if dist > mobj.tracer.scale*1000 then P_TeleportMove(mobj, thex, they, theyz) mobj.momx = 0 mobj.momy = 0 mobj.momz = 0 mobj.scale = mobj.tracer.scale/2 end

	local ns = FixedMul(mobj.info.speed, mobj.tracer.scale)
	if mobj.tracer.player.speed > mobj.info.speed then ns = 5*mobj.tracer.scale + mobj.tracer.player.speed end
	mobj.momz = FixedMul(FixedDiv(zdist, dist), ns)
	if dist <= ns*2 then ns = mobj.tracer.player.speed end
	mobj.momx = FixedMul(FixedDiv(thex - mobj.x, dist), ns)
	mobj.momy = FixedMul(FixedDiv(they - mobj.y, dist), ns)
	if abs(zdist) < abs(mobj.momz) then mobj.momz = zdist end
end, MT_FOLLOWEGG)

//Why can't I define this in SOC
addHook("MobjSpawn", function(mobj) mobj.shadowscale = FRACUNIT/2 end, MT_FOLLOWEGG)
addHook("MobjSpawn", function(mobj) mobj.shadowscale = FRACUNIT/2 end, MT_YOSHIEGG)

//Super Wing Thinker
addHook("MobjThinker", function(mobj)
	if not (mobj.tracer and mobj.tracer.valid and mobj.tracer.player
	and mobj.tracer.skin == "yoshi" and (mobj.tracer.player.powers[pw_super] or mobj.tracer.player.powers[pw_carry] == CR_NIGHTSMODE)) then P_KillMobj(mobj) return end
	mobj.destscale = mobj.tracer.scale*3/2
	mobj.rollangle = mobj.tracer.rollangle
	
	if (mobj.tracer.eflags & MFE_VERTICALFLIP)
		mobj.eflags = $|MFE_VERTICALFLIP
		mobj.flags2 = $|MF2_OBJECTFLIP
	else
		mobj.eflags = $ & ~MFE_VERTICALFLIP
		mobj.flags2 = $ & ~MF2_OBJECTFLIP
	end
	
	if (mobj.tracer.flags2 & MF2_DONTDRAW)
		if not (mobj.flags2 & MF2_DONTDRAW) then mobj.flags2 = $|MF2_DONTDRAW end
	elseif (mobj.flags2 & MF2_DONTDRAW)
		mobj.flags2 = $ & ~MF2_DONTDRAW
	end
	
	if mobj.tracer.player.flutter
		if mobj.state != S_YOSHI_WING_2 then mobj.state = S_YOSHI_WING_2 end
	else
		mobj.state = S_YOSHI_WING_1
	end
	
	local angerle = ANGLE_135
	if mobj.threshold > 0 then angerle = ANGLE_225 end
	local heightdiv = 2
	if (mobj.tracer.sprite2 == SPR2_ROLL) then heightdiv = 4 end
	P_TeleportMove(mobj, P_ReturnThrustX(nil, mobj.tracer.player.drawangle-angerle, 5*mobj.tracer.scale)+mobj.tracer.x,
	P_ReturnThrustY(nil, mobj.tracer.player.drawangle-angerle, 5*mobj.tracer.scale)+mobj.tracer.y,
	mobj.tracer.z+(mobj.tracer.height/heightdiv))
	if (mobj.tracer.eflags & MFE_VERTICALFLIP) then mobj.z = mobj.tracer.z+mobj.tracer.height-mobj.height-(mobj.tracer.height/heightdiv) end
	mobj.angle = R_PointToAngle2(mobj.x, mobj.y, mobj.tracer.x, mobj.tracer.y)
end, MT_YOSHIWING)

//Boots of Steel
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if not (target and target.valid and target.player and target.skin == "yoshi") then return end
	if source and source.valid and source.player then target.player.eggdelay = TICRATE/2 return end
	if damagetype == DMG_SPIKE and not (inflictor and inflictor.valid) then return true end
	if (inflictor and inflictor.valid and inflictor.type == MT_SPIKE and (target.eflags & MFE_VERTICALFLIP) == (inflictor.eflags & MFE_VERTICALFLIP)) then return true end
	if (inflictor and inflictor.valid and inflictor.type == MT_WALLSPIKE) then return end
	if not (inflictor and inflictor.valid and not P_IsObjectOnGround(target)) then return end
	
	local bottomheight = target.z
	local topheight = target.z + target.height

	if (target.eflags & MFE_VERTICALFLIP)
		local swap = bottomheight
		bottomheight = topheight
		topheight = swap
	end

	if not ((P_MobjFlip(target)*(bottomheight - (inflictor.z + inflictor.height/2)) > 0)
	and (P_MobjFlip(target)*(target.momz - inflictor.momz) < 0)) then return end

	local spoark = P_SpawnMobjFromMobj(target, 0, 0, 0, MT_THUNDERCOIN_SPARK)
	spoark.fuse = TICRATE/3
	spoark.scale = target.scale*3/2
	S_StartSound(target, sfx_ysstmp)
	target.momz = max(abs(target.momz), 10*target.scale)
	target.z = $+(inflictor.height/2)
	return true
end, MT_PLAYER)

//Egg Breaking via player attacks in Battle Mode
//Taken from the code for Fang's cork
addHook("ShouldDamage", function(pmo,mo,source)
	if not(CBW_Battle and mo and mo.valid and mo.type == MT_YOSHIEGG and mo.flags&MF_MISSILE) then return end
	local B = CBW_Battle
	if pmo.player and source and source.valid and source.player and not(B.MyTeam(source.player,pmo.player))
		local vulnerable = B.PlayerCanBeDamaged(pmo.player)
-- 		B.DoSPriority(pmo.player,mo)
		if vulnerable and pmo.player.battle_def != 0 then
			B.ResetPlayerProperties(pmo.player,false,false)
			local thrust
			if P_IsObjectOnGround(pmo) then
				thrust = 12
				P_InstaThrust(pmo,mo.angle,mo.scale*thrust)		
				pmo.state = S_PLAY_SKID
			else
				//pmo.momz = $/2
				//P_SetObjectMomZ(pmo,FRACUNIT*10/B.WaterFactor(pmo),1)
				thrust = 5
				P_InstaThrust(pmo,mo.angle,mo.scale*thrust)
				pmo.state = S_PLAY_FALL
			end
			S_StartSound(pmo,sfx_s3k7b)
			//Do uncurling, skidding
			local time = thrust
			local angle = R_PointToAngle2(0,0,pmo.momx,pmo.momy)
			local recoilthrust = FixedHypot(pmo.momx,pmo.momy)
			B.DoPlayerFlinch(pmo.player, thrust, angle, recoilthrust)
			P_KillMobj(mo)
			return false
		elseif not(vulnerable) then
			P_Thrust(pmo,mo.angle,mo.scale*12)
			S_StartSound(mo,sfx_s3k7b)		
			return false
		else
			return true
		end
	end
end, MT_PLAYER)

//Flutter Starter
addHook("AbilitySpecial", function(player)
	if player.mo.skin ~= "yoshi" then return false end
	//Ground Pound Starter
	if (player.cmd.buttons & BT_CUSTOM1) and not P_IsObjectInGoop(player.mo)
		if P_RandomChance(FRACBITS)
			player.yoshieaster = true
			S_StartSound(player.mo, sfx_ysgnp3)
		else
			player.yoshieaster = false
			S_StartSound(player.mo, sfx_ysgnp1)
		end
		if player.eggshoot then player.eggshoot = false end
		P_InstaThrust(player.mo, player.mo.angle, 0)
		P_SetObjectMomZ(player.mo, 0, false)
		player.pflags = $|PF_FULLSTASIS
		player.groundpound = true
		player.flutter = false
		player.timire = 0
	return true end
	
	if player.flutter or player.secondjump > 0 or P_IsObjectInGoop(player.mo) then return true end
	
	player.flutter = true
	if player.eggshoot then player.eggshoot = false end
	if player.powers[pw_super] then return true end
	player.mo.state = S_YOSHI_FLUTTER
	S_StartSound(player.mo, sfx_ysfltr)
	local dehthang = FixedDiv(P_GetMobjGravity(player.mo)*14*P_MobjFlip(player.mo), player.mo.scale)
	if player.pflags & PF_THOKKED
		player.firstflutter = false
	else
		dehthang = FixedDiv(P_GetMobjGravity(player.mo)*5*P_MobjFlip(player.mo), player.mo.scale)
		player.pflags = $|PF_THOKKED
		player.firstflutter = true
	end
	if player.mo.momz > dehthang then P_SetObjectMomZ(player.mo, dehthang, true) end
	player.secondjump = 6
	return true
end)

//No using shields if you're not holding jump at the same time
addHook("ShieldSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "yoshi"
	and not ((player.powers[pw_shield] & SH_NOSTACK) > 1
	and (player.powers[pw_shield] & SH_NOSTACK) != SH_PINK and player.cmd.buttons&BT_JUMP
	and not (player.pflags&PF_SHIELDABILITY) and not (player.pflags&PF_THOKKED))
		return true
	end
end)

//Spike Destroyer
local yoshispike = function(thing, tmthing)
  if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing.type == MT_YOSHIEGG then P_KillMobj(thing, tmthing) return true end
	if tmthing.player and tmthing.skin == "yoshi" and (abs(thing.z - tmthing.z) <= 60*tmthing.scale)
		if tmthing.player.groundpound and tmthing.player.timire == 15
			local bottomheight = tmthing.z
			local topheight = tmthing.z + tmthing.height

			if (tmthing.eflags & MFE_VERTICALFLIP)
				local swap = bottomheight
				bottomheight = topheight
				topheight = swap
			end

			if not ((P_MobjFlip(tmthing)*(bottomheight - (thing.z + thing.height/2)) > 0)
			and (P_MobjFlip(tmthing)*(tmthing.momz - thing.momz) < 0)) then return end
			
			P_KillMobj(thing, tmthing, tmthing)
			return true
		end
	end
end
addHook("MobjCollide", function(thing, tmthing) yoshispike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) yoshispike(thing, tmthing) end, MT_WALLSPIKE)

//Allow jumping in the air after getting spat out
addHook("JumpSpecial", function(player)
	if not (player.mo and player.mo.valid)
	or P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or player.powers[pw_carry] != CR_NONE
	or player.spectator
	or player.playerstate != PST_LIVE
	or not player.mo.health
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol] > 0
	or player.pflags&PF_JUMPDOWN
	or player.yoshiairjump != 1
	return end
	
	player.pflags = $&~PF_JUMPED
	P_DoJump(player, false)
	if player.mo.skin != "yoshi"
		S_StartSound(player.mo,sfx_jump)
	elseif not player.yoshijump
		S_StartSound(player.mo, sfx_ysjump)
	elseif player.yoshijump == 1
		S_StartSound(player.mo, sfx_smwjmp)
	elseif P_RandomChance(FRACUNIT/2)
		S_StartSound(player.mo, sfx_ysjmp1)
	else
		S_StartSound(player.mo, sfx_ysjmp2)
	end
	if player.yoshiairfriendly
		player.mo.state = S_PLAY_JUMP
		player.pflags = $|P_GetJumpFlags(player)|PF_JUMPDOWN
	else
		player.mo.state = S_PLAY_SPRING
		player.pflags = $|PF_NOJUMPDAMAGE|PF_JUMPDOWN
	end
	player.mo.momx = $/2
	player.mo.momy = $/2
	player.yoshiairjump = 0
end)

//Reset the variables when you spawn
addHook("PlayerSpawn", function(player)
	if player.yoshiautoaim == nil then player.yoshiautoaim = true end
	player.yoshiairjump = 0
	player.groundpound = false
	player.timire = 0
	player.flutter = false
	player.eggshoot = false
	player.mouthobj = nil
	player.tongue = nil
	player.yosheggs = 0
	player.eggdelay = 0
	if player.mo and player.mo.valid and
	player.mo.skin == "yoshi" and player.rings > 0
	and not (CBW_Battle and CBW_Battle.BattleGametype)
		local i = min(player.rings/3, 8)
		while player.yosheggs < i SpawnEgg(player) end
	end
end)

//Support for Battle Mode
local ScriptLoaded = false
addHook("ThinkFrame",do
	if not(ScriptLoaded) and CBW_Battle then
		ScriptLoaded = true
		local B = CBW_Battle
		
		//Egg Lay Ability
		local function BattleEgg(mo,doaction)
			local player = mo.player
			if player.yosheggs != nil
				player.actiontext = "Lay Egg "..player.yosheggs.."/8"
			else
				player.actiontext = "Lay Egg"
			end
			player.actionrings = 10
			player.action2rings = 0
			
			if not(B.CanDoAction(player))
				player.actionstate = 0 --Default action state
			return end
			
			if player.groundpound or player.tongue player.canguard = false return end
				
			if player.actionstate == 0
				if doaction == 1 
					if player.yosheggs != nil
					and player.yosheggs < 8
						player.actionstate = 1
						player.actiontime = 10
						B.PayRings(player)
						SpawnEgg(mo.player)
						S_StartSound(mo, sfx_ysmake)
					else
						S_StartSound(mo,sfx_s3k8c,player)
					end
				end
			end
			
			if player.actionstate == 1
				if player.actiontime
					player.actiontime = $-1
					//player.mo.momx = $*9/10
					//player.mo.momy = $*9/10
					mo.state = S_YOSHI_MAKE
					player.pflags = $|PF_FULLSTASIS
				else
					mo.state = S_PLAY_WALK
					player.actionstate = 0
					B.ApplyCooldown(player,TICRATE)
				end
			end
		end
		
		local PriorityFunc = function(player)
			if player.groundpound and player.timire <= 20
			and player.timire >= 15
				B.SetPriority(player,0,0,"stomp_damage",3,1,"ground pound")
			end
		end
		
		CBW_Battle.SkinVars["yoshi"] = {
			weight = 115,
			shields = 0,
			special = BattleEgg,
			func_priority_ext = PriorityFunc
		}
	end
end)

//The spark generator code used for ground nuke and when hitting a spring with the ground pound
local nukesparks = function(inflictor, ns)
	local i = 0
	
	while i < 16
		local fa = (i*(ANGLE_180/8))
		local mo = P_SpawnMobj(inflictor.x, inflictor.y, inflictor.z, MT_SUPERSPARK)
		if mo and mo.valid
			mo.momx = FixedMul(sin(fa),ns)
			mo.momy = FixedMul(cos(fa),ns)
		end
		i = $+1
	end
end

//Custom version of P_NukeEnemies that will hit monitors, spikes, and never hit players in the air.
local groundnuke = function(inflictor, source, radius)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		
		if not (mo.flags & MF_SHOOTABLE) and not (mo.type == MT_EGGGUARD or mo.type == MT_MINUS
		or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE)
			continue
		end

		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
		
		if not P_IsObjectOnGround(mo)
			continue
		end

		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue // Workaround for possible integer overflow in the below -Red
		end

		if P_AproxDistance(P_AproxDistance(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end

		if mo.type == MT_MINUS and not (mo.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mo.flags = (mo.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end

		if mo.type == MT_EGGGUARD and mo.tracer //nuke Egg Guard's shield!
			P_KillMobj(mo.tracer, inflictor, source, DMG_NUKE)
		end
		
		if mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
			P_KillMobj(mo, inflictor, source, DMG_NUKE) //just murder spikes!
		end

		//Unlike the orignal script this always deals one damage, no matter what
		P_DamageMobj(mo, inflictor, source, 1, DMG_NUKE)
	end
end

addHook("MobjThinker", function(mobj)
	if not netgame and mobj.state == S_RING
	and yoshicoin
		mobj.type = MT_COIN
		mobj.state = S_COIN1
	end
end, MT_RING)

addHook("MobjThinker", function(mobj)
	if not netgame and mobj.state == S_RING
	and yoshicoin
		mobj.type = MT_FLINGCOIN
		mobj.state = S_COIN1
	end
end, MT_FLINGRING)

//Main Yoshi Think Code
addHook("PlayerThink", function(player)
	//Global Stuff
	if player.tongue and player.tongue.target
		player.prevmouthobj = player.tongue.target
		player.mouthtimer = TICRATE*2
	elseif player.mouthobj
		player.prevmouthobj = player.mouthobj
		player.mouthtimer = TICRATE*2
	elseif player.mouthtimer and player.mouthtimer > 0
		player.mouthtimer = $-1
	else
		player.prevmouthobj = nil
	end
	
	if player.tongue and player.tongue.valid and player.tongue.target
	and player.tongue.target.valid
		if (player.tongue.target.player and player.tongue.target.player.playerstate == PST_LIVE)
		or (player.tongue.target.health and not player.tongue.target.player)
			if player.mo.mouthed and player.tongue.target.mouthed player.tongue.target.mouthed = 10 end
			mouththink(player.tongue.target)
		else
			player.tongue.target = nil
		end
	elseif player.mouthobj and player.mouthobj.valid
		if (player.mouthobj.player and player.mouthobj.player.playerstate == PST_LIVE)
		or (player.mouthobj.health and not player.mouthobj.player)
			if player.mo.mouthed and player.mouthobj.mouthed player.mouthobj.mouthed = 10 end
			mouththink(player.mouthobj)
		else
			player.mouthobj = nil
		end
	elseif player.prevmouthobj and player.prevmouthobj.valid
		if (player.prevmouthobj.player and player.prevmouthobj.player.playerstate == PST_LIVE)
		or (player.prevmouthobj.health and not player.prevmouthobj.player)
			mouththink(player.prevmouthobj)
		else
			player.prevmouthobj = nil
		end
	end
	
	if not (player.mo and player.mo.valid) then return end
	
	if player.yoshiairjump
		if P_IsObjectOnGround(player.mo) or player.pflags&PF_JUMPED
			player.yoshiairjump = 0
		elseif player.yoshiairjump > 1
			player.yoshiairjump = $-1
		end
	end
	
	if player.mo.skin ~= "yoshi"
		player.mouthobj = nil
		player.yosheggs = 0
		player.groundpound = false
		player.flutter = false
		player.eggshoot = false
		if player.tongue != nil
			if player.tongue.target != nil
				P_TeleportMove(player.tongue.target, player.mo.x, player.mo.y, player.mo.z)
				player.tongue.target.mouthed = 10
				mouththink(player.tongue.target)
			end
			P_RemoveMobj(player.tongue)
			player.tongue = nil
		end
		if player.redic and player.redic.valid then P_RemoveMobj(player.redic) end
		return
	end
	
	//
	//Yoshi-Specific Stuff
	//
	
	//Now why isn't there a blue super color in vanilla?
	//Doesn't matter now though because custom colors are a thing :]
	//if player.mo.color == SKINCOLOR_SUPERSKY1 player.mo.color = SKINCOLOR_AETHER end
	//if player.mo.color == SKINCOLOR_SUPERSKY2 player.mo.color = SKINCOLOR_BLUEBELL end
	//if player.mo.color == SKINCOLOR_SUPERSKY3 player.mo.color = SKINCOLOR_CORNFLOWER end
	//if player.mo.color == SKINCOLOR_SUPERSKY4 player.mo.color = SKINCOLOR_BLUE end
	//if player.mo.color == SKINCOLOR_SUPERSKY5 player.mo.color = SKINCOLOR_COBALT end
	
	//Makes it so Fire Flowers make you red instead of white
	if player.powers[pw_shield]&SH_FIREFLOWER and player.mo.color == SKINCOLOR_WHITE
	player.mo.color = SKINCOLOR_RED end
	
	if player.mouthobj and player.mouthobj.health <= 0 then player.mouthobj = nil end
	
	if player.mo.mouthed and player.mo.mouthed > 0 then player.mouthobj = nil end
	
	if player.eggdelay == nil
		player.eggdelay = 0
	elseif player.eggdelay > 0
		player.eggdelay = $-1
	end
	
	//Super Wing Spawner
	if player.powers[pw_super] == 2
		local chickenwing = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_YOSHIWING)
		chickenwing.tracer = player.mo
		chickenwing.threshold = 0
		chickenwing = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_YOSHIWING)
		chickenwing.tracer = player.mo
		chickenwing.threshold = 1
	end
	
	//Mario Invincibility Music
	if player.powers[pw_invulnerability] == 20*TICRATE and not mariomode
		P_PlayJingleMusic(player, "_MINV", 0, false, JT_INV)
	end
	
	//Delete the redical if not aiming
	if player.redic and player.redic.valid and
	((not player.eggshoot) or player.eggshoot and not (player.lockon and player.lockon.valid)) then P_RemoveMobj(player.redic) end
	
	//Player's momz variable but accounted for antigravity, used for checks
	local momzGrv = player.mo.momz
	if	(player.mo.eflags & MFE_VERTICALFLIP)
		momzGrv = -1*(momzGrv)
	end
	
	//Spin Button Pressing code from the Custom Character
	//Ability Tutorial on the Wiki because it's useful
	if not (player.cmd.buttons & BT_USE)
		player.spintapready = true
		player.spintapping = false
	elseif player.spintapready then
		player.spintapping = true
		player.spintapready = false
	else
		player.spintapping = false
	end
	
	if not (player.cmd.buttons & BT_CUSTOM1)
		player.customtapready = true
		player.customtapping = false
	elseif player.customtapready then
		player.customtapping = true
		player.customtapready = false
	else
		player.customtapping = false
	end
	
	if player.mo.frame == FF_ANIMATE|G and (player.mo.sprite2 == SPR2_PAIN or player.panim == PA_PAIN)
		player.mo.anim_duration = -1
	end
	
	//Disallows the rest of the code in certain circumstances
	if P_PlayerInPain(player)
	or (player.pflags & PF_SLIDING)
	or player.exiting != 0
	or player.powers[pw_carry] != CR_NONE
	or player.spectator
	or player.playerstate != PST_LIVE
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.powers[pw_nocontrol] > 0
		if (player.playerstate != PST_LIVE or player.spectator
		or player.iseggrobo or player.isjettysyn or not player.mo.health)
		and player.mouthobj and player.mouthobj.valid and player.mouthobj.mouthed
		and player.mouthobj.mouthed < 10
		player.mouthobj.mouthed = 10 mouththink(player.mouthobj) end
		if player.groundpound then player.groundpound = false player.mo.rollangle = 0 end
		player.timire = 0
		player.flutter = false
		if player.eggshoot then player.eggshoot = false end
		if player.tongue != nil
			if player.tongue.target != nil
				P_TeleportMove(player.tongue.target, player.mo.x, player.mo.y, player.mo.z)
				player.tongue.target.mouthed = 10
				mouththink(player.tongue.target)
			end
			P_RemoveMobj(player.tongue)
			player.tongue = nil
		end
		return
	end
	
	if P_IsObjectOnGround(player.mo) then player.juum = false end
	
	//Jump Sounds
	if (player.pflags & PF_STARTJUMP)
		if not player.juum and not mariomode
			player.juum = true
			if not player.yoshijump
				S_StartSound(player.mo, sfx_ysjump)
			elseif player.yoshijump == 1
				S_StartSound(player.mo, sfx_smwjmp)
			elseif P_RandomChance(FRACUNIT/2)
				S_StartSound(player.mo, sfx_ysjmp1)
			else
				S_StartSound(player.mo, sfx_ysjmp2)
			end
		end
	else
		player.juum = false
	end
		
//Main State Code
	
	//Tongue Code (basically a Thinker for the tongue that's run by
	//the source player rather than the tongue itself
	if player.tongue and player.tongue.valid
		if player.tongue.reactiontime <= -44
			if player.tongue.target and player.tongue.target.valid and player.tongue.target.health
				player.mouthobj = player.tongue.target
				player.mouthobj.tracer = player.mo
				player.mouthobj.mouthed = 2
			end
			P_RemoveMobj(player.tongue)
			player.tongue = nil
			player.mo.state = S_PLAY_WALK
		else
			//Makes Metal Sonic dodge out of the way when you try to tongue him
			searchBlockmap("objects", function(refmobj, foundmobj)
				if foundmobj and foundmobj.valid and foundmobj.type == MT_METALSONIC_BATTLE
				and foundmobj.health and foundmobj.state == S_METALSONIC_FLOAT
					//That's right, we're doing this the hard way.
					foundmobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh),
					FixedDiv((foundmobj.info.spawnhealth - foundmobj.health)<<FRACBITS, (foundmobj.info.spawnhealth-1)<<FRACBITS)))
					if (P_RandomChance(FRACUNIT/2)) then foundmobj.movedir = InvAngle(foundmobj.movedir) end
					foundmobj.threshold = 6 + (FixedMul(24<<FRACBITS, FixedDiv((foundmobj.info.spawnhealth - foundmobj.health)<<FRACBITS, (foundmobj.info.spawnhealth-1)<<FRACBITS))>>FRACBITS)
					if (foundmobj.info.activesound) then S_StartSound(foundmobj, foundmobj.info.activesound) end
					if (foundmobj.info.painchance) then foundmobj.state = foundmobj.info.painchance end
					foundmobj.flags2 = $ & ~MF2_INVERTAIMABLE
				end
			end, player.tongue)
			
			if (player.mo.flags2 & MF2_DONTDRAW)
				if not (player.tongue.flags2 & MF2_DONTDRAW) then player.tongue.flags2 = $|MF2_DONTDRAW end
			elseif (player.tongue.flags2 & MF2_DONTDRAW)
				player.tongue.flags2 = $ & ~MF2_DONTDRAW
			end
			
			if (player.mo.eflags & MFE_VERTICALFLIP)
				player.tongue.eflags = $|MFE_VERTICALFLIP
				player.tongue.flags2 = $|MF2_OBJECTFLIP
				P_TeleportMove(player.tongue, (P_ReturnThrustX(nil, player.tongue.angle, player.tongue.threshold*player.mo.scale)+player.mo.x),
				(P_ReturnThrustY(nil, player.tongue.angle, player.tongue.threshold*player.mo.scale)+player.mo.y),
				player.mo.momz+player.mo.z+player.mo.height-player.tongue.height-(player.mo.height*4/7))
			else
				player.tongue.eflags = $ & ~MFE_VERTICALFLIP
				player.tongue.flags2 = $ & ~MF2_OBJECTFLIP
				P_TeleportMove(player.tongue, (P_ReturnThrustX(nil, player.tongue.angle, player.tongue.threshold*player.mo.scale)+player.mo.x),
				(P_ReturnThrustY(nil, player.tongue.angle, player.tongue.threshold*player.mo.scale)+player.mo.y),
				player.mo.height*4/7+player.mo.z+player.mo.momz)
			end
			
			if player.tongue.target
				P_TryMove(player.tongue.target, player.tongue.x, player.tongue.y, true)
				player.tongue.target.z = player.tongue.z
			end
			player.tongue.threshold = $+player.tongue.reactiontime
			player.tongue.tracer = player.mo
			player.drawangle = player.tongue.angle
			player.tongue.reactiontime = $-5
			player.timire = $+5
			player.pflags = $|PF_FULLSTASIS
			player.mo.state = S_PLAY_FIRE
		end
		
	//Ground Pound (or Hip Drop as the N64 Mario Parties like to call it)
	//Once again stolen code from my Crash Lua
	elseif player.groundpound
		player.mo.state = S_PLAY_SPINDASH
		if momzGrv > 0 or P_IsObjectInGoop(player.mo)
		or (player.timire > 15 and not P_IsObjectOnGround(player.mo))
		or (player.mo.eflags & MFE_SPRUNG)
			if momzGrv > 0 and not P_IsObjectInGoop(player.mo)
			and player.timire <= 15 and not (player.mo.eflags & MFE_SPRUNG) then player.mo.momz = $*2/3 end
			//Spring Boost
			if (player.mo.eflags & MFE_SPRUNG)
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				S_StartSound(player.mo, sfx_sprong)
				nukesparks(player.mo, 15 << FRACBITS)
			end
			player.timire = 0
			player.groundpound = false
			player.mo.rollangle = 0
		elseif P_IsObjectOnGround(player.mo)
			if player.timire < 30
				if player.timire < 15 then player.timire = 15
					if player.yoshieaster then S_StartSound(player.mo, sfx_ysgnp4)
					else S_StartSound(player.mo, sfx_ysgnp2)
				end	end
				if player.timire <= 20 then groundnuke(player.mo, player.mo, RING_DIST*2/3) end
				if player.timire == 15
					nukesparks(player.mo, 30 << FRACBITS)
					S_StartSound(player.mo, sfx_cannon)
					local prevheight = player.mo.height
					P_SetScale(player.mo, player.mo.scale*4/5)
					if (player.mo.eflags & MFE_VERTICALFLIP)
						player.mo.z = $+(prevheight-player.mo.height)
					end
				end
				player.timire = $ + 1
			else
				player.timire = 0
				player.groundpound = false
			end
		elseif player.timire == 15
			local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
			if sectorthing.valid then
				for fof in sectorthing.ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and (abs(fof.topheight - player.mo.z) <= 30*player.mo.scale) then
						EV_CrumbleChain(player.sectorthing, fof)
					end
				end
			end
		else
			P_SetObjectMomZ(player.mo, 0, false)
			player.timire = $ + 1
			if player.timire == 15
				if player.yoshieaster
					S_StartSound(player.mo, sfx_ysgnp4)
				else
					S_StartSound(player.mo, sfx_ysgnp2)
				end
				P_SetObjectMomZ(player.mo, -20*FRACUNIT, false)
			elseif player.timire > 5
				player.mo.rollangle = 0
			else
				player.mo.rollangle = player.timire*ANG60
			end
		end
		player.pflags = $|PF_FULLSTASIS
		
	//Flutter Jump and Super Flight
	elseif player.flutter
		//Ground Pound Starter
		if (player.cmd.buttons & BT_CUSTOM1) and not P_IsObjectInGoop(player.mo)
			if P_RandomChance(FRACBITS)
				player.yoshieaster = true
				S_StartSound(player.mo, sfx_ysgnp3)
			else
				player.yoshieaster = false
				S_StartSound(player.mo, sfx_ysgnp1)
			end
			P_InstaThrust(player.mo, player.mo.angle, 0)
			P_SetObjectMomZ(player.mo, 0, false)
			player.pflags = $|PF_FULLSTASIS
			player.groundpound = true
			player.flutter = false
			player.timire = 0
		//Canceller
		elseif player.timire >= 45 or P_IsObjectOnGround(player.mo) or (player.mo.eflags & MFE_SPRUNG)
		or (not (player.cmd.buttons & BT_JUMP) and ((player.timire > 5) or player.powers[pw_super]))
			if player.powers[pw_super]
				S_StartSound(player.mo, sfx_ysflyb)
			elseif player.timire < 45
				local i = 0
				while i < 10
					S_StopSound(player.mo)
					i = $ + 1
				end
			end
			player.mo.state = S_PLAY_FALL
			player.flutter = false
		//Flight
		elseif player.powers[pw_super]
			player.mo.state = S_PLAY_JUMP
			if momzGrv < 7*player.mo.scale
				P_SetObjectMomZ(player.mo, 2*FRACUNIT, true)
				player.mo.momz = max(min(player.mo.momz, 7*player.mo.scale), -7*player.mo.scale)
			end
			if not S_SoundPlaying(player.mo, sfx_ysflya) then S_StartSound(player.mo, sfx_ysflya) end
		//Flutter
		else
			if not player.firstflutter
				player.mo.momx = $*95/100
				player.mo.momy = $*95/100
			end
			if not player.mo.state == S_YOSHI_FLUTTER then player.mo.state = S_YOSHI_FLUTTER end
			P_SetObjectMomZ(player.mo, FixedDiv(P_GetMobjGravity(player.mo)*-4/3*P_MobjFlip(player.mo), player.mo.scale), true)
			if player.secondjump == 6
				player.secondjump = 5
			else
				player.mo.momz = max(min(player.mo.momz*P_MobjFlip(player.mo), 5*player.mo.scale), -6*player.mo.scale)*P_MobjFlip(player.mo)
			end
			player.timire = $+1
		end
		
	//Egg Throw
	elseif player.eggshoot
		if player.spintapping
			player.eggshoot = false
		elseif (player.customtapping and not player.yoshithrow) or (player.yoshithrow and not (player.cmd.buttons & BT_CUSTOM1))
			local bullet
			if player.lockon and player.lockon.valid
				bullet = P_SpawnMissile(player.mo, player.lockon, player.revitem)
				S_StartSound(player.mo, sfx_ysthrw)
			else
				bullet = P_SpawnPlayerMissile(player.mo, player.revitem)
				S_StartSound(player.mo, sfx_ysnoeg)
			end
			if bullet and bullet.valid then
				bullet.scale = player.mo.scale*3/2
				bullet.name = "Flying Egg"
				if player.powers[pw_super]
					bullet.color = SKINCOLOR_BLUE
				else
					bullet.color = player.mo.color
				end
			end
			player.yosheggs = $-1
			player.eggshoot = false
		else
			if player.lockon and player.lockon.valid
				player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, player.lockon.x, player.lockon.y)
				if not S_SoundPlaying(player.mo, sfx_ysaim) then S_StartSound(player.mo, sfx_ysaim) end
			//else
				//player.lockon = EnemyLookDeluxe(player)
			end
			player.drawangle = player.mo.angle
		end
	else
		player.timire = 0
		
		if player.secondjump > 0 then player.secondjump = $-1 end
		
		local lockon
		if player.yoshiautoaim and player.mouthobj and player.mouthobj.valid
		and player.mouthobj.info.deathstate != S_NULL
		and (not player.mouthobj.player or gametyperules&GTR_FRIENDLY
		or (G_GametypeHasTeams() and player.ctfteam == player.mouthobj.player.ctfteam))
			lockon = EnemyLookDeluxe(player, 1, ANGLE_45)
			if lockon and lockon.valid then P_SpawnLockOn(player, lockon, S_LOCKON1) end
		end
		
		if player.mo.state == S_PLAY_SPINDASH then player.mo.state = S_PLAY_WALK end
		
		if player.spintapping and not (player.pflags & PF_SHIELDABILITY)
		
			//Spitting
			if player.mouthobj and player.mouthobj.valid
				S_StartSound(player.mo, sfx_ysspit)
				
				local xeah = player.mouthobj.x
				local yeah = player.mouthobj.y
				local zeah = player.mouthobj.z
				local xoh = player.mo.x
				local yoh = player.mo.y
				local zoh = player.mo.z
				
				player.mouthobj.mouthed = 3
				mouththink(player.mouthobj)
				P_InstaThrust(player.mouthobj, 0, 0)
				
				//Aim spit
				if lockon and lockon.valid
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
					player.drawangle = player.mo.angle
					local z = player.mo.z + player.mo.height/2
					if (player.mo.eflags & MFE_VERTICALFLIP) then z = $-FixedMul(player.mouthobj.height, source.scale) end
					player.mouthobj.momz = (lockon.z - z) / (P_AproxDistance(lockon.x - player.mo.x, lockon.y - player.mo.y)/((35*player.mo.scale)+player.speed))
					P_SetObjectMomZ(player.mouthobj, FRACUNIT, true)
				elseif player.aiming*P_MobjFlip(player.mo) > 0
					P_SetObjectMomZ(player.mouthobj, min(AngleFixed(player.aiming), 20*FRACUNIT), false)
				else
					P_SetObjectMomZ(player.mouthobj, 0, false)
				end
				
				//Prevent wall clipping
				P_TeleportMove(player.mouthobj, player.mo.x, player.mo.y, player.mo.height/2+player.mo.z)
				if P_TryMove(player.mo, xeah, yeah, true)
					P_TeleportMove(player.mo, xoh, yoh, zoh)
					if P_TryMove(player.mouthobj, xeah, yeah, true) 
						P_InstaThrust(player.mouthobj, player.drawangle, (35*player.mo.scale)+player.speed)
					end
				end
				
				player.mouthobj.angle = player.drawangle
				player.mouthobj = nil
				player.mo.state = S_PLAY_FIRE
			//Tonguing
			else
				player.tongue = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, player.drawangle, 24*player.mo.scale), 
				P_ReturnThrustY(nil, player.drawangle, 24*player.mo.scale), FixedDiv(player.mo.height, player.mo.scale)*4/7, MT_YOSHITONGUE)
				player.tongue.flags2 = $|MF2_DONTDRAW
				player.tongue.angle = player.drawangle
				player.tongue.tracer = player.mo
				player.tongue.threshold = 72
				player.tongue.scale = $/4
				S_StartSound(player.mo, sfx_ystong)
			end
		
		//Egg Lay and Egg Throw Starter
		elseif player.customtapping
			//Lay
			if player.mouthobj and player.mouthobj.valid and
			(not (player.mouthobj.info.deathstate == S_NULL
			or (player.mouthobj.player and (player.mouthobj.player.bot == 0 and not yoshieggify)))
			or player.mouthobj.type == MT_GOOP or player.mouthobj.type == MT_UNIBALL)
			and not (player.mouthobj.flags & MF_MONITOR)
				S_StartSound(player.mo, sfx_ysgulp)
				if player.mouthobj.player
					P_KillMobj(player.mouthobj)
					player.mouthobj.flags2 = $|MF2_DONTDRAW
					S_StopSound(player.mouthobj)
					if player.mouthobj.player.bot != 0
						player.mouthobj.tracer = nil
						player.mouthobj.target = nil
						player.mouthobj.state = S_BLACKEGG_HELPER
					end
				else
					P_RemoveMobj(player.mouthobj)
				end
				player.mouthobj = nil
				if player.yosheggs < 8
					SpawnEgg(player)
					S_StartSound(player.mo, sfx_ysmake)
					player.mo.state = S_YOSHI_MAKE
				end
			elseif player.yosheggs <= 0
				//S_StartSound(player.mo, sfx_ysnoeg)
				player.eggshoot = false
			//Throw
			elseif not player.eggdelay
				player.eggshoot = true
				if player.yoshiautoaim player.lockon = EnemyLookDeluxe(player, 4, ANGLE_45) end
				if player.lockon and player.lockon.valid then
					player.redic = P_SpawnMobjFromMobj(player.mo, player.lockon.x, player.lockon.y, player.lockon.z, MT_YOSHIRETICULE)
					player.redic.target = player.mo
					player.redic.tracer = player.lockon
					player.redic.scale = player.mo.scale
				else
					S_StartSound(player.mo, sfx_ysprep)
				end
			end
		end
	end
end)